#ifndef _GRAPH_H
#define _GRAPH_H

#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include <vector>
#include <map>
#include <deque>
#include <algorithm>
#include <utility>
#include <cmath>
//#include <hash_map.h>
#include <algorithm>
#include <errno.h>
#include "BitVec/BitVec.hh"
#include "types.hh"


using namespace std;

#define MAX_VAL 10000000
#define MIN_VAL -10000000

/*struct Vertex {
	bool visited;
	bool fat;	// fat node
	int topo_id;	// topological order
	int path_id;	// path id
	int dfs_order;
	int pre_order;
	int post_order;
	int first_visit; // for test
};
*/
// typedef vector<int> EdgeList;	// edge list represented by vertex id list
// typedef vector<Vertex> VertexList;	// vertices list (store real vertex property) indexing by id

typedef int ranking;
typedef int vertex;
//typedef unsigned short int weight;
typedef double weight;
//#define WEIGHTLIMIT 2147483647
//#define WEIGHTLIMIT 65535
typedef map<ranking, vertex> hyperedge;
typedef map<vertex, weight> edge;


/*struct edge{
	short int vertex;
	short int weight;
}
*/

class Graph {
	private:
		int V;
		int E;

	public:
		int sizeV(){return V;};
		int sizeE();
		int *order;
//		unsigned short int **adjacency_matrix;//vertices as row and column
		edge *adjacency_list;
		Graph(int);
		Graph();
		Graph(const Graph&);
		~Graph();
		Graph& operator=(const Graph&);
		int Graphcost();
		void Graph_display();


};

class Hypergraph{
	private:
		int V;
		int E;

	public:
		int sizeV(){return V;};
		int sizeE(){return E;};
		int *order;
		BitVec *transaction_matrix;//edges as row, vertices as column


		Hypergraph(int,int);//(V,E)
		~Hypergraph();
		int Hypercost();
		Graph Hypertograph_Line(int* vertex_mapping_table, int* reverse_vertex_mapping_table, vector<int>& isolated_vertices);
		Graph Hypertograph_Loop(int* vertex_mapping_table, int* reverse_vertex_mapping_table, vector<int>& isolated_vertices);
//		Graph Hypertograph_Clique();
		Graph Hypertograph_Multiloop(int* vertex_mapping_table, int* reverse_vertex_mapping_table, vector<int>& isolated_vertices);
		void Hypergraph_display();
};


#endif
